/*
  TREE.C    v.1.10    7/04/1999
  Copyright (c) 1999   Ing. Loris Penserini   All Rights Reserved

  ESEMPIO DI POSSIBLE GESTIONE DI UN ALBERO N-ARIO

  Il prog. permette la creazione dell'albero e la sua stampa.
  L'aggiunta di un nodo figlio viene eseguita specificando
  l'identificativo (IDnode) del nodo padre, l'IDnode viene
  assegnato in modo automatico (ed incrementale) dal prog..

  E' stata utilizzata in alcuni casi, per semplificare la
  formattazione dell'output, l'istruzione del C++: 'cout'.

  Il prog. prevede nella struttura 'node', un puntatore al
  nodo precedente: 'prec_node', che nell'attuale versione di
  TREE.C viene utilizzato solamente per la stampa dell'albero.
*/

#include <stdio.h>
#include <conio.h>
#include <iostream.h>
#include <alloc.h>
#include <process.h>

struct node{//Struttura dei nodi dell'albero
 int  key;
 struct node *prec_node;
 struct list *list_nodes;
} *root_node, *current_node;

struct list{//I nodi hanno una lista, i cui elementi
	    //indirizzano eventualmente altri nodi.
 struct list *next_element_list;
 struct node *next_node;
} *root_list, *current_list;

void PrintTree(struct node *ptr_node,
	       struct list *ptr_list);//Stampa l'albero

void InsertNode(struct node *ptr_node);//In accoppiata con 'FindNode'
				       //inserisce nodi.
struct node *FindNode(int key_node, struct node *ptr_node,
		      struct list *ptr_list);

//Funzioni che allocano memoria alle nuove strutture
struct node *Init_node(struct node *ptr_node);
struct list *Init_list(struct list *ptr_list);

int IDnode = 0;//Identificatore del nodo
int flg = 0;

 //******************************************************
 //************************ MAIN ************************
 main()
 {
  char ris;

  clrscr();

  //Inizializza la radice dell'albero
  //(root node & root list) e prepara
  //'current_node/list' ai valori iniziali.
  root_node = Init_node(root_node);
  root_list = Init_list(root_list);
  root_node->list_nodes = root_list;
  root_node->key = IDnode;
  current_node = root_node;
  current_list = root_list;

  //*********************
  //Gestione dell'albero
  //*********************
  while((ris !=  'E')&&(ris !=  'e')){
   printf("\n             ******************************************\n");
   printf("\n             ********* GESTIONE ALBERO N-ARIO *********\n");
   printf("\n             ******************************************\n\n\n");
   printf("\n   >> Aggiungi Nodo (N), Stampa albero (S), Esci (E): ");
   ris = getch();

   if((ris == 'N')||(ris == 'n')){//**** Inserimento NODO ****
    int coord = -2;
    clrscr();
    printf("\n                      ********* AGGIUNTA NODO *********\n\n");
    while((coord != -1)&&(coord !=  -1)){
     printf("\n\n     >> Su quale nodo aggiungiamo un nodo figlio (-1 per uscire)? ");
     scanf("%d",&coord);
     if(coord != -1){
       current_node = FindNode(coord, root_node, root_list);
       if(current_node == NULL){
	 printf("\n         *** Errore! nodo non trovato. ***\n");
	 getch();
       } else{
	   cout<<"\n       - Nodo padre: "<< current_node;
	   InsertNode(current_node);
	 }
     }
    }//End while coord
   }//End if N

   if((ris == 'S')||(ris == 's')){//Stampa albero (senza criteri)
     clrscr();
     printf("\n                       ********* STAMPA ALBERO *********\n\n");
     PrintTree(root_node, root_list);
     flg = 0;
     getch();
   }
   clrscr();
  }//End while ris
  getch();
  return(0);
 }//************** End main() ******************
  //********************************************

//Funzione di stampa dell'intero albero (IDnode)
void PrintTree(struct node *ptr_node,
	       struct list *ptr_list){
  if((ptr_node->key == 0)&&(flg == 0)){
   flg = -1;
   cout<<"\n   >> Nodo Radice n.: "<<ptr_node->key<<"\n";
  }else if(ptr_list->next_node == NULL){//Stampa le foglie
   cout<<"\n    - Nodo n.: "<<ptr_node->key;
   cout<<"  Figlio di nodo n.: "<<ptr_node->prec_node->key<<"\n";
  }
  if(ptr_list->next_node != NULL){//Si sposta verticalmente
    PrintTree(ptr_list->next_node,
	      ptr_list->next_node->list_nodes);
    if(ptr_list->next_element_list != NULL){//Si muove orizontalmente
      PrintTree(ptr_node, ptr_list->next_element_list);
      if(ptr_node->key != 0){//Per non far stampare la radice piu' volte
       cout<<"\n    - Nodo n.: "<<ptr_node->key;
       cout<<"  Figlio di nodo n.: "<<ptr_node->prec_node->key<<"\n";
      }
    }
  }
}//End PrintTree

//Funzione di inserimento di un nodo su una posizione
//qualunque di un albero n-ario.
 void InsertNode(struct node *current_node){
   struct node *newNode;
   struct list *newElList;
   IDnode++;
   current_list = current_node->list_nodes;
   if(current_list->next_node == NULL)
     cout<<"  con Lista iniziale: "<< current_list;
   //Se la lista ha altri elementi, ne creo uno nuovo in fondo
   if(current_list->next_node != NULL){
     int ele = 0;
     while(current_list->next_node != NULL){
       ele++;
       cout<<"\n       - Elemento "<<ele<<" della lista: "<<current_list;
       newElList = current_list;
       current_list = current_list->next_element_list;
     }
     current_list = Init_list(current_list);
     newElList->next_element_list = current_list;
     cout<<"\n       - Ultimo elemento che punta al nuovo nodo: "<< current_list;
   }
   newNode = Init_node(current_list->next_node);
   newNode->prec_node = current_node;
   current_list->next_node = newNode;

   //Nodo figlio
   current_node = newNode;
   current_list = Init_list(current_node->list_nodes);
   current_node->list_nodes = current_list;
   current_node->key = IDnode;

   if(IDnode == 1)
     root_list->next_node = current_node;

   printf("\n        *Creato nodo figlio: %d, di padre: %d",
	   current_node->key,
	   current_node->prec_node->key,"\n\n");
   cout<<"\n       - Nodo creato: "<< current_node;
   cout<<"  con Lista: "<< current_list;
 }//End InsertNode

 //Cerca il nodo identificato da 'coord'
 struct node *FindNode(int coord, struct node *ptr_node,
		     struct list *ptr_list){
  if(ptr_node->key == coord) return(ptr_node);
  if(ptr_list->next_node != NULL){
    ptr_node = FindNode(coord, ptr_list->next_node,
		    ptr_list->next_node->list_nodes);
    if(ptr_node->key == coord) return(ptr_node);
    if(ptr_list->next_element_list != NULL){
      ptr_node = FindNode(coord, ptr_list->next_element_list->next_node,
			  ptr_list->next_element_list->next_node->list_nodes);
      if(ptr_node->key == coord) return(ptr_node);
    }
  }
  return(ptr_node = NULL);
 }//End FindNode

 //Si inizializza il blocco di memoria per la lista
 struct list *Init_list(struct list *ptr_list){
  ptr_list = (struct list *) malloc(sizeof(struct list));
  if(ptr_list == NULL){
   printf("Errore di memoria. Un tasto per uscire...");
   getch();
   exit(1);
  }
  ptr_list->next_element_list = NULL;
  ptr_list->next_node = NULL;
  return(ptr_list);
 }

 //Si inizializza il blocco di memoria per il nodo
 struct node *Init_node(struct node *ptr_node){
  ptr_node = (struct node *) malloc(sizeof(struct node));
  //ptr_node->prec_node = current_node;
  if(ptr_node == NULL){
   printf("Errore di memoria. Un tasto per uscire...");
   getch();
   exit(1);
  }
  ptr_node->prec_node = NULL;
  ptr_node->list_nodes = NULL;
  return(ptr_node);
 }//End Init_node()

